// EspionM3.cpp : lecture pridique du millenium 3 de crouzet
// V1.0 Original
// V1.1 Correction erreur ouverture rpertoire destination
// V1.2 Ajout des Messages Erreur systme + Soft Purge
// V1.3 Utilisation de ClearCommError + Erreur dans la boucleppal sur purge COMM
// V1.4 retir message box sur purge COMM

#define WINVER 0x0410

#include <afxwin.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <memory.h>     
#include <string.h>
#include <conio.h>
#include <io.h>
#include <fcntl.h>
#include "psapi.h"
#include "stdafx.h"
#include <process.h>
#include <winioctl.h>

BOOL OpenInitCom(long wOpenOnly,long PortNum,char *Mess);
HANDLE OpenFile(void);
BOOL  ReInitComs(long PortNum);
BOOL SendReadM3Message(long PortNum);
BOOL ReadM3Reponse(long PortNum);
void SleepWait(LARGE_INTEGER Timer, double Delay);
BOOL TranslateAndWrite2file(void);
void PrintErrorSys(DWORD Errnum,char *szMsg);
void SoftPurge(void);
void CloseComm(void);


#define BUFLEN 4096
char szError[ BUFLEN ];
char szError2[2*BUFLEN ];
char szBufRec[BUFLEN];
char *szInitM3=":010300006D00018E\r\n";
char *szTitle="M3 Spy";
LARGE_INTEGER T0Reference,FrequencyCounter;
long StartSloutAdr=25;
long wNbData=24;
long nbVersion=2;
long nbFileError=0;
HANDLE  hComm ;


/**********************************************************************/
/**********************************************************************/
/**************************** MAIN*************************************/
/**********************************************************************/
/**********************************************************************/
int  main(int argc,char *argv[])
{	
  // boucle principale, on ne sort de cette application que par
  // la fermeture violente de la fentre...
    long    PortNum=4;
    long    Freq=30;
    BOOL    bCommsOk=TRUE;
    long    nbCommsErr=0;
//init et lecture des paramtres
   if (argc >1) sscanf(argv[1],"%ld" ,&PortNum);
   if (argc >2) sscanf(argv[2],"%ld" ,&Freq);
   if (argc >3) sscanf(argv[3],"%ld" ,&nbVersion);
   if (argc >4) sscanf(argv[4],"%ld" ,&wNbData);
 
//output console des paramtres pris en compte
   sprintf(szError,"\n\n\n\n\n                          M3 Spy (V1.4):\n\n\nCet utilitaire (gratuit) comporte des erreurs...\n\nParametres:\nPort serie #%d, Periode: %dsecondes, Version %d, Nombre de donnees %d\n\n",
             PortNum,Freq,nbVersion,wNbData);
   printf(szError);

   //DEBUG CREATION REPERTOIRE
   ////HANDLE  hFile ;
   ////hFile=OpenFile();
   ////DWORD dwCount,Err;
   ////sprintf(szError,"toto\r\n");
   ////if(0==WriteFile(hFile,szError,strlen(szError),&dwCount,NULL))
   ////{
   ////   Err=GetLastError();
   ////   sprintf(szError,"\n Echec Write => %ld",Err);
   ////   printf(szError);

   ////}
   ////sprintf(szBufRec,"%s => %ld\n",szError,strlen(szError));
   ////printf(szBufRec);
   ////CloseHandle(hFile);

//init timer
   QueryPerformanceFrequency(&FrequencyCounter);
// premier test port srie
   if (!OpenInitCom(0,PortNum,"Init"))
   {
      printf("\nNoComms\n");
      MessageBox(NULL,"Pas de port serie detecte",szTitle,MB_OK);
      return(-1);  // ya pas de port de com portant ce numero => sortie
	 }
   else
   {
     CloseComm();
// envoi du message d'init vers M3 en boucle jusqu'a ce que cela marche
     ReInitComs(PortNum);  

// Boucle principale interroge le M2 toutes les Freq seconde et
// ecrit le rsultat dans le fichier portant le nom du jour
     while(TRUE)
     {
       QueryPerformanceCounter(&T0Reference);
//envoi du message d'interrogation
       bCommsOk=SendReadM3Message(PortNum);
       if (bCommsOk)
       {
// le M3 est long  rpondre inutile d'occuper le PC
         SleepWait(T0Reference,3);
         bCommsOk=ReadM3Reponse(PortNum);
       }
       if (bCommsOk)
       {
//traduction de la rponse et ecriture dans le fichier
         if (!TranslateAndWrite2file())
         {
           if ((nbFileError++) > 5)
           {
             printf(szError,"\nPlus de 5 erreurs ecriture fichier\n");
             nbFileError=0;
           }
         }
         else
         {
            nbFileError=0;
         }
         SleepWait(T0Reference,Freq); // ici boucle d'attente entre 2 acquisition
       }
       else
       {
 //Il y a des erreurs de com: tentative(s) de rcupration
         nbCommsErr++;
         if (nbCommsErr > 5)  // on a peut-tre coup le M3 qq instants?
         {
           printf("\nErreurs de communication: Reinitialisation\n");
           ReInitComs(PortNum);  // envoi du message d'init vers M3 en boucle jusqu'a ce que cela marche
           nbCommsErr=0;
         }
         if (OpenInitCom(2,PortNum,"InitPurge") )
         {  // en cas d'erreur on vide de toutes faon les buffers.
           PurgeComm( hComm, PURGE_TXABORT | PURGE_RXABORT |
                PURGE_TXCLEAR | PURGE_RXCLEAR ) ;
           CloseComm();
         }
       }
     }     
   }
   return 0;
} //main

/**********************************************************************/
/**********************************************************************/
BOOL OpenInitCom(long wOpenOnly,long PortNum,char *msg)
{
  //ouverture du port comm et si c'est la premire fois (wOpenOnly=0) initialisation
    char          szPort[ 15 ];
    char          szLocErrMess[100];
    COMMTIMEOUTS  CommTimeOuts ;
    DWORD         dwErrors;
    COMSTAT       commStat;
    
    CloseComm();// securit contre les bug de ce soft!!!!

    sprintf( szPort, "\\\\.\\COM%d",PortNum ) ;
    if ((hComm=
      CreateFile( szPort, GENERIC_READ | GENERIC_WRITE,
                  0,                    // exclusive access
                  NULL,                 // no security attrs
                  OPEN_EXISTING,
                  FILE_ATTRIBUTE_NORMAL, // overlapped I/O
                  NULL )) == (HANDLE) -1 ) {
      sprintf(szLocErrMess,"<Ouverture Com (%s)>",msg);
      PrintErrorSys(GetLastError(),szLocErrMess);
      if (wOpenOnly==0)
      {
        sprintf(szError,"\nImpossible ouvrir le port com %ld (%s)\n",PortNum,szPort);
        printf(szError);
        MessageBox(NULL,szError,szTitle,MB_OK);
      }
      hComm=NULL;
      return(FALSE);
	  }
    else
    {
      if (wOpenOnly!=1)
      {
              // get any early notifications
        SetCommMask( hComm, EV_RXCHAR ) ;
        // setup device buffers
        SetupComm( hComm, BUFLEN, BUFLEN ) ;
        CommTimeOuts.ReadIntervalTimeout = 200; //Attente entre 2 char
        CommTimeOuts.ReadTotalTimeoutMultiplier = 500; // Attente par char
        CommTimeOuts.ReadTotalTimeoutConstant = 500; //attente en plus
        CommTimeOuts.WriteTotalTimeoutMultiplier = 0 ;
        CommTimeOuts.WriteTotalTimeoutConstant = 0 ;
        SetCommTimeouts(hComm, &CommTimeOuts ) ;
      }
      ClearCommError(hComm,&dwErrors,&commStat);
      return(TRUE);
    }
}//initcomms


/**********************************************************************/
/**********************************************************************/
HANDLE OpenFile(void)
{
//ouverture du fichier de sortie dont le nom est cr d'aprs la date du jour

__time64_t ltime;
struct tm *today;
char FileName[128];
char *DirName=".\\DonneesSolaires\\";
HANDLE hFile;
DWORD Err;

  _time64( &ltime );
  today = _localtime64( &ltime );
  strftime( szError, 128,"%y_%m_%d_Solar.dat", today );
  sprintf(FileName,"%s%s",DirName,szError);
//  printf( FileName );
  if ((hFile=
    CreateFile( FileName,  FILE_APPEND_DATA | FILE_WRITE_ATTRIBUTES | 
                STANDARD_RIGHTS_WRITE,
                FILE_SHARE_READ,                    
                NULL,                 // no security attrs
                OPEN_ALWAYS,
                FILE_ATTRIBUTE_NORMAL,
                NULL )) == (HANDLE) -1 ) 
  {
    sprintf(szError,"\nCreation repertoire destination <%s>\n",DirName );
    printf(szError);
    if (!CreateDirectory(DirName,NULL))
    {
      Err=GetLastError();
      if (Err !=ERROR_ALREADY_EXISTS)
      {
        PrintErrorSys(Err,"<Ouverture Fichier (createDir)>");
        sprintf(szError,"\n Echec Creation Repertoire Donnees <%s> => %ld", FileName,Err);
        MessageBox(NULL,szError,szTitle,MB_OK);
        return(NULL);
      }
    }
    if ((hFile=
      CreateFile( FileName,  FILE_APPEND_DATA | FILE_WRITE_ATTRIBUTES | 
                  STANDARD_RIGHTS_WRITE,
                  FILE_SHARE_READ,                    // exclusive access
                  NULL,                 // no security attrs
                  OPEN_ALWAYS,
                  FILE_ATTRIBUTE_NORMAL,
                  NULL )) == (HANDLE) -1 ) 
    {
      PrintErrorSys(GetLastError(),"<Ouverture Fichier (openFile)>");
      return(NULL);
    }
  }
  return(hFile);
}// openfile



/**********************************************************************/
/**********************************************************************/
BOOL ReInitComs(long PortNum)
{
  // envoi du message d'init vers M3 en boucle jusqu' ce que cela marche
  //ie jusqu' ce qu'il rponde
  BOOL bCommsOK=FALSE;
  DWORD dwCount;
  DWORD dwErrors;
  COMSTAT commStat;

  while (!bCommsOK)
  {
    sprintf(szError,"\nInitialisation: Ouverture port serie #%ld  :",PortNum);
    printf(szError);
    if (!OpenInitCom(2,PortNum,"ReInit(2)") )
    {
      printf("Echec: nouvel Essai dans 10s\n");
      Sleep(10000);
    }
    else
    {
      printf("OK\nEnvoi sequence Initialisation:");
      SoftPurge();
      bCommsOK=TRUE;
    }
  }//while
  bCommsOK=FALSE;
  while (!bCommsOK)
  {
    SoftPurge();
    if (WriteFile(hComm,szInitM3,strlen(szInitM3),&dwCount,0)==0)
    {
      PrintErrorSys(GetLastError(),"<Ecriture Message Init M3>");
      ClearCommError(hComm,&dwErrors,&commStat);
      sprintf(szError,"ClearCommMsg:%ld, left for Rx:%ld, left for Tx:%ld",dwErrors,commStat.cbInQue,commStat.cbOutQue);
      printf(szError);
    }
    if (strlen(szInitM3) == dwCount)
    {
      printf("Ok\nAttente Reponse:");
      Sleep(1000);
      if (ReadFile(hComm,szBufRec,11,&dwCount,0)==0)
      {
        PrintErrorSys(GetLastError(),"<Lecture Message Init M3>");
        ClearCommError(hComm,&dwErrors,&commStat);
        sprintf(szError,"ClearCommMsg:%ld, left for Rx:%ld, left for Tx:%ld",dwErrors,commStat.cbInQue,commStat.cbOutQue);
        printf(szError);
     }
      if (dwCount >=11)
      {
        bCommsOK=TRUE;
        printf("Ok: INITIALISATION REUSSIE\n\n");
      }
      else
      {
        sprintf(szError,"\n\nEchec read recu:%ld/ Demande:%ld\n Nouvel essai dans 30s\n",dwCount,11);
        printf(szError);
        Sleep(30000);
        PurgeComm( hComm, PURGE_TXABORT | PURGE_RXABORT |
                          PURGE_TXCLEAR | PURGE_RXCLEAR ) ;
      }
    }// if Write OK
    else
    {
      sprintf(szError,"Echec WRITE %ld/%ld\n Nouvel essai dans 30s\n",dwCount,strlen(szInitM3));
      printf(szError);
      Sleep(30000);
      PurgeComm( hComm, PURGE_TXABORT | PURGE_RXABORT |
                        PURGE_TXCLEAR | PURGE_RXCLEAR ) ;
    }
  }//while
  CloseComm();
  return(TRUE);
}//ReinitComms




/**********************************************************************/
/**********************************************************************/
void ConvertShortToHexAscii(short Data,char *szDest)
{
//convertion de un octey en 2 char (Hexascii)
  char  szOut[2];
  sprintf(szOut,"%2X",Data);
  strcat(szDest,szOut);
}


/**********************************************************************/
/**********************************************************************/
void MakeReadMessage(long slinAdr,long NbData,char *szBuf)
{
  // cration du message  envoyer au M3 pour lire NbData  partir de l'adresse slinAdr
  long chkSum=0;
  strcpy(szBuf,":04030000FF");
  chkSum=4+3+255;
  ConvertShortToHexAscii(short(slinAdr),szBuf);
  chkSum+=short(slinAdr);
  ConvertShortToHexAscii(short(2*NbData),szBuf);
  chkSum+=short(2*NbData);
  chkSum=256-(chkSum % 256);
  ConvertShortToHexAscii(short(chkSum),szBuf);
  strcat(szBuf,"\r\n");
}

/**********************************************************************/
/**********************************************************************/
BOOL  SendReadM3Message(long PortNum)
{
  // envoi du message de lecture
  char szBuf[BUFLEN];
  DWORD dwCount,dwErrors;
  COMSTAT commStat;

  if (!OpenInitCom(1,PortNum,"Lecture"))
  {
    return(FALSE);
  }
  else
  {
    SoftPurge();
    MakeReadMessage(StartSloutAdr-1,wNbData,szBuf);
    if (WriteFile(hComm,szBuf,strlen(szBuf),&dwCount,0)==0)
    {
      PrintErrorSys(GetLastError(),"<Ecriture Message Lecture M3>");
      ClearCommError(hComm,&dwErrors,&commStat);
      sprintf(szError,"ClearCommMsg:%ld, left for Rx:%ld, left for Tx:%ld",dwErrors,commStat.cbInQue,commStat.cbOutQue);
      printf(szError);
    }
    CloseComm();
    return(dwCount==strlen(szBuf));
  }
}

/**********************************************************************/
/**********************************************************************/
BOOL ReadM3Reponse(long PortNum)
{
  // lecture de la rponse du M3
  DWORD dwCount,dwErrors;
  BOOL retValue;
  COMSTAT commStat;
  if (!OpenInitCom(1,PortNum,"Lecture"))
  {
    return(FALSE);
  }
  else
  {
    // il y a 4*wNbData (2 char par Octet et 2 octets par donnes)
    // + 11 octets kiservarien
    if (ReadFile(hComm,szBufRec,11+4*wNbData,&dwCount,0)==0)
    {
      PrintErrorSys(GetLastError(),"<Lecture Message M3>");
      ClearCommError(hComm,&dwErrors,&commStat);
      sprintf(szError,"ClearCommMsg:%ld, left for Rx:%ld, left for Tx:%ld",dwErrors,commStat.cbInQue,commStat.cbOutQue);
      printf(szError);
   }
    retValue=(dwCount==11+4*wNbData);
    CloseComm();
    if (!retValue)
    {
      sprintf(szError,"\nErreur Lecture Recu:%ld/Demande:%ld\n",dwCount,11+4*wNbData);
      printf(szError);
    }
    return(retValue);
  }
}

/**********************************************************************/
/**********************************************************************/
void  SleepWait(LARGE_INTEGER Timer, double Delay)
{
  // endort le process jusqu' ce que heureAcuelle-Timer soir suprieure  Delay
  // indispensable pouyr que cette appli ne bouffe pas tout le CPU
  LARGE_INTEGER T0;
  double timed=0;

  while (timed <= Delay)
  {
    QueryPerformanceCounter(&T0);
    timed=((double)(T0.QuadPart-Timer.QuadPart)/(double)FrequencyCounter.QuadPart);
    if (timed < Delay-1) Sleep((DWORD)(Delay-timed-1)*1000);
    else Sleep(100);
  }
}


/**********************************************************************/
/**********************************************************************/
unsigned char HexAscii2Short(char *ptrChar)
{
// convertit 2 char en un octet Hexascii -> hexa
  unsigned char Value;
  unsigned char Octet;

  Octet=(unsigned char)(*(ptrChar+1));
  if (Octet <= 57) Octet -=48;
  else Octet-=55;
  Value=Octet;
  Octet=(unsigned char)(*(ptrChar));
  if (Octet <= 57) Octet -=48;
  else Octet-=55;
  Value+=16*Octet;
  return(Value);
}

/**********************************************************************/
/**********************************************************************/
long HexAscii2ShortArray(short *sOutput)
{
  // convertit szBufRec (la rponse du M3) en un tableau de short
  char *ptrChar;
  long i,nb;
  unsigned char *ptrCharOut;

  ptrChar=szBufRec+5;
  nb=HexAscii2Short(ptrChar)/2;
  if (nb > 100) nb=100;
  ptrChar+=2;
  ptrCharOut=(unsigned char *)sOutput;
  for (i=0;i<nb;i++)
  {// convert also from little to big endian
    ptrCharOut[2*i+1]=HexAscii2Short(ptrChar);
    ptrChar+=2;
    ptrCharOut[2*i]=HexAscii2Short(ptrChar);
    ptrChar+=2;
  }
  return(nb);
}

/**********************************************************************/
/**********************************************************************/
BOOL TranslateAndWrite2file(void)
{
  // Ecriture d'une ligne de donnes dans le fichier de sortie

  HANDLE hFile;
  BOOL  RetValue=FALSE;
  DWORD dwCount;
  short sOutput[100];
  char szTampon[100];
  __time64_t ltime;
  struct tm *today;
  long nb,i;

  nb=HexAscii2ShortArray(sOutput);

  hFile=OpenFile();
  RetValue= (hFile !=NULL);
  if (RetValue) 
  {
    sprintf(szTampon,"%ld\t",nbVersion);
    WriteFile(hFile,szTampon,strlen(szTampon),&dwCount,0);
    _time64( &ltime );
    today = _localtime64( &ltime );
    strftime(szTampon ,100,"%d/%m/%Y\t%H:%M:%S", today );
    WriteFile(hFile,szTampon,strlen(szTampon),&dwCount,0);
    sprintf(szError,"\rDerniere ecriture:%s                         \r",szTampon);
    printf(szError);
    for (i=0; i<nb;i++)
    {
      sprintf(szTampon,"\t%d",sOutput[i]);
      WriteFile(hFile,szTampon,strlen(szTampon),&dwCount,0);
    }
    WriteFile(hFile,"\r\n",2,&dwCount,0);
    CloseHandle(hFile);
    hFile=NULL;
  }
  return(RetValue);
}//Translate&Write2file


//***************************************************************
void PrintErrorSys(DWORD ErrNum,char *szMsg)
{
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM ,
            NULL,
            ErrNum,
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
            szError,
            BUFLEN,
            NULL );
        sprintf(szError2,"\n\n%s : Erreur Systeme #%ld, %s\n",szMsg,ErrNum,szError);
        printf(szError2);
}


//***************************************************************
void SoftPurge(void)
{
  DWORD dwCount=1;
  DWORD LoopCount=0;
  DWORD dwErrors;
  COMSTAT commStat;
  long nbChar;

  while ((dwCount !=0) && (LoopCount < 1000))
  {
    ClearCommError(hComm,&dwErrors,&commStat);
    nbChar=commStat.cbInQue;
    if (nbChar == 0) nbChar=1;// lire au moins 1 caractre
    ReadFile(hComm,szError,nbChar,&dwCount,0);
    LoopCount++;
  }
  if (LoopCount >= 1000)
  {
    printf("\n\nAttention:Erreur sur Purge Buffer Reception\n");
    PurgeComm( hComm, PURGE_TXABORT | PURGE_RXABORT |
                  PURGE_TXCLEAR | PURGE_RXCLEAR ) ;
  }
}

void CloseComm(void)
{
   if (hComm != NULL) CloseHandle(hComm);
   hComm=NULL;
}